import { select, selectAll } from 'd3';
import Topologica from 'topologica';

// Computes a color string.
const color = ({r, g, b}) => `rgb(${r},${g},${b})`;
color.dependencies = ['r', 'g', 'b'];

// Sets the background color.
const background = ({color}) => {
  select('body').style('background-color', color);
};
background.dependencies = ['color'];

const state = Topologica({ color, background });

// Sets r, g, or b for a given input element (this).
function setColorComponent() {
  state.set({
    [this.id]: this.value
  });
}

selectAll('input')
  .each(setColorComponent)
  .on('input', setColorComponent);